/* $Id: gps.h,v 1.6 2012-03-03 11:39:33 simimeie Exp $
 * Functions for handling the GPS receiver 
 * (and the time reception done through it)
 */

#ifndef _GPS_H_
#define _GPS_H_

#include "timers.h"

struct gpstime {
  uint32_t unixts;  /* Unix timestamp! */
  struct timestamp devicetime; /* device time at the above unixts */
  uint8_t issummertime;
};

#ifdef GPS

extern struct gpstime gpstime[2];
/* Which of the two gpstime structs above is the currently valid one.
 * (the other is filled in on the next PPS) */
extern volatile uint8_t gpsvalid;

/* Updated every 5 seconds: Number of satellites in view. */
extern uint8_t gpssatsinview;

#endif /* GPS */

void gps_init(void);

/* Returns 1 if successful, 0 if not. */
uint8_t gps_configurereceiver(void);

#endif /* _GPS_H_ */
