/* $Id: timeconvert.h,v 1.3 2010-08-28 18:31:14 simimeie Exp $
 * Routines for handling various time representations.
 * Mainly conversion routines from broken time to timestamps and the other
 * way round.
 */

#ifndef _TIMECONVERT_H_
#define _TIMECONVERT_H_

#include <inttypes.h>

struct brokentime {
  uint8_t year; /* without the century, i.e. 10 not 2010. Minimum year is 1! */
  uint8_t month;
  uint8_t day;
  uint8_t hour;
  uint8_t min;
  uint8_t sec;
};

extern int32_t tc_timezoneoffset; /* Has to be signed of course */
extern uint8_t tc_handledst;

/* Converts a brokentime-struct (UTC!) to a timestamp */
uint32_t bttots(struct brokentime * bt);

/* Converts a timestamp to a brokentime-struct (UTC!) */
void tstobt(uint32_t ts, struct brokentime * bt);

/* Returns the day of week at the given timestamp.
 * 0 = Sunday, 1 = Monday, ... 6 = Saturday  */
uint8_t getdayofweek(uint32_t ts);

/* Returns 1 if summertime, 0 if not.
 * The reason you have to give the year argument is that this
 * makes it so much easier to calculate this.
 * And the only place where this function is currently called already
 * has that information :) */
uint8_t isdst(uint32_t ts, uint8_t year);

#endif
